{
    "$graph": [
        {
            "label": "align_filter",
            "class": "CommandLineTool",
            "baseCommand": "align_filter",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "aligns.mft",
                            "entry": "${var blob = '# aligns.mft created for align_filter from input \"input\" Array of Files\\n'; for (var i = 0; i < inputs.input.length; i++) { blob += inputs.input[i].path + '\\n'; } return blob; }"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "inputBinding": {
                        "prefix": "-asn-cache",
                        "itemSeparator": ","
                    },
                    "id": "#align_filter.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-filter"
                    },
                    "id": "#align_filter.cwl/filter"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-ifmt"
                    },
                    "id": "#align_filter.cwl/ifmt"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#align_filter.cwl/input"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "aligns.mft",
                    "inputBinding": {
                        "prefix": "-input-manifest"
                    },
                    "id": "#align_filter.cwl/input_mft"
                },
                {
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "prefix": "-nogenbank"
                    },
                    "id": "#align_filter.cwl/nogenbank"
                },
                {
                    "type": "string",
                    "default": "align.asn",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#align_filter.cwl/o_name"
                },
                {
                    "type": "string",
                    "default": "align-nomatch.asn",
                    "inputBinding": {
                        "prefix": "-non-match-output"
                    },
                    "id": "#align_filter.cwl/onon_match_name"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-subject-allowlist"
                    },
                    "id": "#align_filter.cwl/subject_allowlist"
                }
            ],
            "id": "#align_filter.cwl",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.o_name)"
                    },
                    "id": "#align_filter.cwl/o"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.onon_match_name)"
                    },
                    "id": "#align_filter.cwl/onon_match"
                }
            ]
        },
        {
            "id": "#align_find_frequent_sas.cwl",
            "label": "align_find_frequent_sas",
            "class": "CommandLineTool",
            "baseCommand": "align_find_frequent",
            "doc": "",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-input"
                    },
                    "id": "#align_find_frequent_sas.cwl/align_find_frequent/align"
                },
                {
                    "type": "string",
                    "default": "seq-align-set",
                    "inputBinding": {
                        "prefix": "-ifmt"
                    },
                    "id": "#align_find_frequent_sas.cwl/align_find_frequent/ifmt"
                },
                {
                    "type": "string",
                    "default": "frequent.seq_ids",
                    "inputBinding": {
                        "prefix": "-out"
                    },
                    "id": "#align_find_frequent_sas.cwl/align_find_frequent/out_name"
                },
                {
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "-row"
                    },
                    "id": "#align_find_frequent_sas.cwl/align_find_frequent/row"
                },
                {
                    "type": "int",
                    "default": 10,
                    "inputBinding": {
                        "prefix": "-threshold"
                    },
                    "id": "#align_find_frequent_sas.cwl/align_find_frequent/threshold"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.out_name)"
                    },
                    "id": "#align_find_frequent_sas.cwl/align_find_frequent/frequent"
                }
            ]
        },
        {
            "label": "blastn_wnode",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.blastdb_dir)",
                            "writable": false
                        }
                    ]
                }
            ],
            "baseCommand": "blastn_wnode",
            "arguments": [
                "-nogenbank"
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "Directory"
                    ],
                    "inputBinding": {
                        "prefix": "-asn-cache"
                    },
                    "id": "#blastn_wnode.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "prefix": "-best_hit_overhang"
                    },
                    "id": "#blastn_wnode.cwl/best_hit_overhang"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "prefix": "-best_hit_score_edge"
                    },
                    "id": "#blastn_wnode.cwl/best_hit_score_edge"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-blastdb",
                        "valueFrom": "$(inputs.blastdb_dir.path)/$(inputs.blastdb)"
                    },
                    "id": "#blastn_wnode.cwl/blastdb"
                },
                {
                    "type": [
                        "null",
                        "Directory"
                    ],
                    "id": "#blastn_wnode.cwl/blastdb_dir"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-dust"
                    },
                    "id": "#blastn_wnode.cwl/dust"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0.01,
                    "inputBinding": {
                        "prefix": "-evalue"
                    },
                    "id": "#blastn_wnode.cwl/evalue"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-input-jobs"
                    },
                    "id": "#blastn_wnode.cwl/input_jobs"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 250,
                    "inputBinding": {
                        "prefix": "-max_target_seqs"
                    },
                    "id": "#blastn_wnode.cwl/max_target_seqs"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "output",
                    "inputBinding": {
                        "prefix": "-O"
                    },
                    "id": "#blastn_wnode.cwl/output_dir"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "prefix": "-perc_identity"
                    },
                    "id": "#blastn_wnode.cwl/perc_identity"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": true,
                    "inputBinding": {
                        "prefix": "-soft_masking"
                    },
                    "id": "#blastn_wnode.cwl/soft_masking"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-swap-rows"
                    },
                    "id": "#blastn_wnode.cwl/swap_rows"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "blastn",
                    "inputBinding": {
                        "prefix": "-task"
                    },
                    "id": "#blastn_wnode.cwl/task"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 12,
                    "inputBinding": {
                        "prefix": "-word_size"
                    },
                    "id": "#blastn_wnode.cwl/word_size"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.output_dir)"
                    },
                    "id": "#blastn_wnode.cwl/outdir"
                }
            ],
            "id": "#blastn_wnode.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "fscr_calls_pass1",
            "label": "fscr_calls_pass1",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "input.mft",
                            "entry": "${var blob = '# input.mft created for fscr_calls_pass1 from input input Array of Files\\n'; for (var i = 0; i < inputs.input.length; i++) { blob += inputs.input[i].path + '\\n'; } return blob; }"
                        }
                    ]
                }
            ],
            "arguments": [
                "-nogenbank"
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-asn-cache"
                    },
                    "id": "#fscr_calls_pass1.cwl/asn_cache"
                },
                {
                    "type": "string",
                    "default": "calls.asn",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#fscr_calls_pass1.cwl/calls_name"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#fscr_calls_pass1.cwl/input"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "input.mft",
                    "inputBinding": {
                        "prefix": "-input-manifest"
                    },
                    "id": "#fscr_calls_pass1.cwl/input_manifest"
                },
                {
                    "type": "string",
                    "default": "masked_locs.asn",
                    "inputBinding": {
                        "prefix": "-masked-locs"
                    },
                    "id": "#fscr_calls_pass1.cwl/masked_locs_name"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-max-reblast-spans"
                    },
                    "id": "#fscr_calls_pass1.cwl/max_reblast_spans"
                },
                {
                    "type": "string",
                    "default": "reblast_locs.asn",
                    "inputBinding": {
                        "prefix": "-reblast-locs"
                    },
                    "id": "#fscr_calls_pass1.cwl/reblast_locs_name"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-repeat-threshold"
                    },
                    "id": "#fscr_calls_pass1.cwl/repeat_threshold"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.calls_name)"
                    },
                    "id": "#fscr_calls_pass1.cwl/calls"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.masked_locs_name)"
                    },
                    "id": "#fscr_calls_pass1.cwl/masked_locs"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.reblast_locs_name)"
                    },
                    "id": "#fscr_calls_pass1.cwl/reblast_locs"
                }
            ],
            "id": "#fscr_calls_pass1.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "fscr_format_calls",
            "arguments": [
                "-nogenbank",
                "-no-taxon-access"
            ],
            "label": "fscr_format_calls",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-calls"
                    },
                    "id": "#fscr_format_calls.cwl/calls"
                },
                {
                    "type": "string",
                    "default": "calls.tab",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#fscr_format_calls.cwl/oname"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.oname)"
                    },
                    "id": "#fscr_format_calls.cwl/o"
                }
            ],
            "id": "#fscr_format_calls.cwl"
        },
        {
            "class": "CommandLineTool",
            "id": "#generate_fscr_feats.cwl",
            "baseCommand": "generate_fscr_feats",
            "arguments": [
                "-nogenbank"
            ],
            "label": "generate_fscr_feats",
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-excluded-seqs"
                    },
                    "id": "#generate_fscr_feats.cwl/generate_fscr_feats/excluded_seqs"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-input"
                    },
                    "id": "#generate_fscr_feats.cwl/generate_fscr_feats/input"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "-label-suffix"
                    },
                    "id": "#generate_fscr_feats.cwl/generate_fscr_feats/label_suffix"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#generate_fscr_feats.cwl/generate_fscr_feats/o"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "-source"
                    },
                    "id": "#generate_fscr_feats.cwl/generate_fscr_feats/source"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.o)"
                    },
                    "id": "#generate_fscr_feats.cwl/generate_fscr_feats/feats"
                }
            ]
        },
        {
            "label": "gp_makeblastdb",
            "class": "Workflow",
            "requirements": [
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "id": "#gp_makeblastdb.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gp_makeblastdb.cwl/asnb"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gp_makeblastdb.cwl/asnt"
                },
                {
                    "type": "string",
                    "id": "#gp_makeblastdb.cwl/dbtype"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gp_makeblastdb.cwl/fasta"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gp_makeblastdb.cwl/hardmask"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gp_makeblastdb.cwl/ids"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gp_makeblastdb.cwl/lds2"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gp_makeblastdb.cwl/molecules"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gp_makeblastdb.cwl/softmask"
                },
                {
                    "type": "string",
                    "id": "#gp_makeblastdb.cwl/title"
                }
            ],
            "steps": [
                {
                    "run": {
                        "class": "CommandLineTool",
                        "requirements": [
                            {
                                "class": "InitialWorkDirRequirement",
                                "listing": [
                                    {
                                        "entry": "$(inputs.molecules)",
                                        "writable": false
                                    }
                                ]
                            }
                        ],
                        "baseCommand": "gp_makeblastdb",
                        "arguments": [
                            "-nogenbank"
                        ],
                        "inputs": [
                            {
                                "type": {
                                    "type": "array",
                                    "items": "Directory"
                                },
                                "inputBinding": {
                                    "prefix": "-asn-cache",
                                    "itemSeparator": ","
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/asn_cache"
                            },
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "inputBinding": {
                                    "prefix": "-asnb"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/asnb"
                            },
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "inputBinding": {
                                    "prefix": "-asnt"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/asnt"
                            },
                            {
                                "type": "string",
                                "inputBinding": {
                                    "prefix": "-dbtype"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/dbtype"
                            },
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "inputBinding": {
                                    "prefix": "-fasta"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/fasta"
                            },
                            {
                                "type": "string",
                                "default": "found_ids.txt",
                                "inputBinding": {
                                    "prefix": "-found-ids-output"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/found_ids_output_file"
                            },
                            {
                                "type": "string",
                                "default": "found_ids.mft",
                                "inputBinding": {
                                    "prefix": "-found-ids-output-manifest"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/found_ids_output_manifest"
                            },
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "inputBinding": {
                                    "prefix": "-hardmask"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/hardmask"
                            },
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "inputBinding": {
                                    "prefix": "-ids"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/ids"
                            },
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "inputBinding": {
                                    "prefix": "-lds2"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/lds2"
                            },
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "id": "#gp_makeblastdb.cwl/actual/run/molecules"
                            },
                            {
                                "type": "string",
                                "default": "blastdb",
                                "inputBinding": {
                                    "prefix": "-db"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/output_db_file"
                            },
                            {
                                "type": "string",
                                "default": "blastdb.mft",
                                "inputBinding": {
                                    "prefix": "-output-manifest"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/output_db_manifest"
                            },
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "inputBinding": {
                                    "prefix": "-softmask"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/softmask"
                            },
                            {
                                "type": "string",
                                "inputBinding": {
                                    "prefix": "-title"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/title"
                            }
                        ],
                        "outputs": [
                            {
                                "type": {
                                    "type": "array",
                                    "items": "File"
                                },
                                "outputBinding": {
                                    "glob": "blastdb.*"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/blastfiles"
                            },
                            {
                                "type": "string",
                                "outputBinding": {
                                    "outputEval": "$(inputs.output_db_file)"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/dbname"
                            },
                            {
                                "type": "File",
                                "outputBinding": {
                                    "glob": "$(inputs.found_ids_output_file)"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/found_ids"
                            }
                        ]
                    },
                    "in": [
                        {
                            "source": "#gp_makeblastdb.cwl/asn_cache",
                            "id": "#gp_makeblastdb.cwl/actual/asn_cache"
                        },
                        {
                            "source": "#gp_makeblastdb.cwl/asnb",
                            "id": "#gp_makeblastdb.cwl/actual/asnb"
                        },
                        {
                            "source": "#gp_makeblastdb.cwl/asnt",
                            "id": "#gp_makeblastdb.cwl/actual/asnt"
                        },
                        {
                            "source": "#gp_makeblastdb.cwl/dbtype",
                            "id": "#gp_makeblastdb.cwl/actual/dbtype"
                        },
                        {
                            "source": "#gp_makeblastdb.cwl/fasta",
                            "id": "#gp_makeblastdb.cwl/actual/fasta"
                        },
                        {
                            "source": "#gp_makeblastdb.cwl/hardmask",
                            "id": "#gp_makeblastdb.cwl/actual/hardmask"
                        },
                        {
                            "source": "#gp_makeblastdb.cwl/ids",
                            "id": "#gp_makeblastdb.cwl/actual/ids"
                        },
                        {
                            "source": "#gp_makeblastdb.cwl/softmask",
                            "id": "#gp_makeblastdb.cwl/actual/softmask"
                        },
                        {
                            "source": "#gp_makeblastdb.cwl/title",
                            "id": "#gp_makeblastdb.cwl/actual/title"
                        }
                    ],
                    "out": [
                        "#gp_makeblastdb.cwl/actual/blastfiles"
                    ],
                    "id": "#gp_makeblastdb.cwl/actual"
                },
                {
                    "run": {
                        "class": "CommandLineTool",
                        "requirements": [
                            {
                                "class": "ShellCommandRequirement"
                            }
                        ],
                        "arguments": [
                            {
                                "shellQuote": false,
                                "valueFrom": "mkdir $(inputs.blastdir) && cp"
                            }
                        ],
                        "inputs": [
                            {
                                "type": "string",
                                "inputBinding": {
                                    "position": 2
                                },
                                "id": "#gp_makeblastdb.cwl/mkdir/run/blastdir"
                            },
                            {
                                "type": {
                                    "type": "array",
                                    "items": "File"
                                },
                                "inputBinding": {
                                    "position": 1
                                },
                                "id": "#gp_makeblastdb.cwl/mkdir/run/blastfiles"
                            }
                        ],
                        "outputs": [
                            {
                                "type": "Directory",
                                "outputBinding": {
                                    "glob": "$(inputs.blastdir)"
                                },
                                "id": "#gp_makeblastdb.cwl/mkdir/run/blastdb"
                            }
                        ]
                    },
                    "in": [
                        {
                            "default": "blastdir",
                            "id": "#gp_makeblastdb.cwl/mkdir/blastdir"
                        },
                        {
                            "source": "#gp_makeblastdb.cwl/actual/blastfiles",
                            "id": "#gp_makeblastdb.cwl/mkdir/blastfiles"
                        }
                    ],
                    "out": [
                        "#gp_makeblastdb.cwl/mkdir/blastdb"
                    ],
                    "id": "#gp_makeblastdb.cwl/mkdir"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputSource": "#gp_makeblastdb.cwl/mkdir/blastdb",
                    "id": "#gp_makeblastdb.cwl/blastdb"
                }
            ],
            "id": "#gp_makeblastdb.cwl"
        },
        {
            "label": "gpx_make_outputs",
            "class": "CommandLineTool",
            "baseCommand": "gpx_make_outputs",
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-input-path"
                    },
                    "id": "#gpx_make_outputs.cwl/input_path"
                },
                {
                    "doc": "this parameter is fixed for this command line workflow, because the output is defined as single file\n",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "-num-partitions"
                    },
                    "id": "#gpx_make_outputs.cwl/num_partitions"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#gpx_make_outputs.cwl/output"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#gpx_make_outputs.cwl/output_glob"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "*",
                    "inputBinding": {
                        "prefix": "-unzip"
                    },
                    "id": "#gpx_make_outputs.cwl/unzip"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_glob)"
                    },
                    "id": "#gpx_make_outputs.cwl/output_file"
                }
            ],
            "id": "#gpx_make_outputs.cwl"
        },
        {
            "label": "gpx_qdump",
            "class": "CommandLineTool",
            "arguments": [
                "-produce-empty-file"
            ],
            "baseCommand": "gpx_qdump",
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-input-path"
                    },
                    "id": "#gpx_qdump.cwl/input_path"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "output.asn",
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#gpx_qdump.cwl/output_name"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-unzip"
                    },
                    "id": "#gpx_qdump.cwl/unzip"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "id": "#gpx_qdump.cwl/output"
                }
            ],
            "id": "#gpx_qdump.cwl"
        },
        {
            "label": "gpx_qsubmit",
            "doc": "This workflow is specialized for the case when there is an LDS2 input  LDS2 is a _reference_ object, the kind that CWL does not like we need to provide actual input: proteins which matches the name of ASN.1 object references in LDS2 Another limitation is that it can handle no more than two item arrays in blastdb_dir and asn_cache Workaround used so far: in:\n  proteins:\n    default:\n        class: File\n        path: '/dev/null'\n        basename: 'null'\n        contents: ''\n",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.proteins)",
                            "writable": false
                        },
                        {
                            "entry": "$(inputs.blastdb_dir)",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=0; var s=inputs.asn_cache.length-1; var as = cs; if(as >= s) {as = s }; return inputs.asn_cache[as]; }",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=1; var s=inputs.asn_cache.length-1; var as = cs; if(as >= s) {as = s }; return inputs.asn_cache[as]; }",
                            "writable": false
                        },
                        {
                            "entryname": "ids.mft",
                            "entry": "${var blob = '# ids.mft created for gpx_qsubmit from input ids Array of Files\\n';for (var i = 0; i < inputs.ids.length; i++) {blob += inputs.ids[i].path  + '\\n';}return blob;}"
                        }
                    ]
                }
            ],
            "baseCommand": "gpx_qsubmit",
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-NxM-threshold"
                    },
                    "id": "#gpx_qsubmit.cwl/NxM_threshold"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "subject",
                    "inputBinding": {
                        "prefix": "-affinity"
                    },
                    "id": "#gpx_qsubmit.cwl/affinity"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "Directory"
                        }
                    ],
                    "inputBinding": {
                        "prefix": "-asn-cache",
                        "itemSeparator": ","
                    },
                    "id": "#gpx_qsubmit.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-batch-size"
                    },
                    "id": "#gpx_qsubmit.cwl/batch_size"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "prefix": "-db",
                        "valueFrom": "${ var blob = ''; for (var i = 0; i < inputs.blastdb.length; i++) { blob += inputs.blastdb_dir.path + '/' + inputs.blastdb[i]; if(i != inputs.blastdb.length-1) blob += ','; } return blob; }"
                    },
                    "id": "#gpx_qsubmit.cwl/blastdb"
                },
                {
                    "type": [
                        "null",
                        "Directory"
                    ],
                    "id": "#gpx_qsubmit.cwl/blastdb_dir"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "id": "#gpx_qsubmit.cwl/ids"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "ids.mft",
                    "inputBinding": {
                        "prefix": "-ids-manifest"
                    },
                    "id": "#gpx_qsubmit.cwl/ids_manifest"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-lds2"
                    },
                    "id": "#gpx_qsubmit.cwl/lds2"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-max-batch-length"
                    },
                    "id": "#gpx_qsubmit.cwl/max_batch_length"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": true,
                    "inputBinding": {
                        "prefix": "-nogenbank"
                    },
                    "id": "#gpx_qsubmit.cwl/nogenbank"
                },
                {
                    "type": "string",
                    "default": "jobs.xml",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#gpx_qsubmit.cwl/output_xml_jobs"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-overlap"
                    },
                    "id": "#gpx_qsubmit.cwl/overlap"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gpx_qsubmit.cwl/proteins"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-queries-gc-id-list"
                    },
                    "id": "#gpx_qsubmit.cwl/queries_gc_id_list"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-subjects-gc-id-list"
                    },
                    "id": "#gpx_qsubmit.cwl/subjects_gc_id_list"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-subseq-size"
                    },
                    "id": "#gpx_qsubmit.cwl/subseq_size"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-xml-jobs"
                    },
                    "id": "#gpx_qsubmit.cwl/xml_jobs"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_xml_jobs)"
                    },
                    "id": "#gpx_qsubmit.cwl/jobs"
                }
            ],
            "id": "#gpx_qsubmit.cwl"
        },
        {
            "label": "prime_cache",
            "class": "CommandLineTool",
            "baseCommand": "prime_cache",
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-biosource"
                    },
                    "id": "#prime_cache.cwl/biosource"
                },
                {
                    "type": "string",
                    "default": "sequence_cache",
                    "inputBinding": {
                        "prefix": "-cache"
                    },
                    "id": "#prime_cache.cwl/cache_dir"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "fasta",
                    "inputBinding": {
                        "prefix": "-ifmt"
                    },
                    "id": "#prime_cache.cwl/ifmt"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-i"
                    },
                    "id": "#prime_cache.cwl/input"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-inst-mol"
                    },
                    "id": "#prime_cache.cwl/inst_mol"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-molinfo"
                    },
                    "id": "#prime_cache.cwl/molinfo"
                },
                {
                    "type": "string",
                    "default": "oseq-ids.seqids",
                    "inputBinding": {
                        "prefix": "-oseq-ids"
                    },
                    "id": "#prime_cache.cwl/seq_ids_name"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-submit-block-template"
                    },
                    "id": "#prime_cache.cwl/submit_block_template"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-taxid"
                    },
                    "id": "#prime_cache.cwl/taxid"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-taxon-db"
                    },
                    "id": "#prime_cache.cwl/taxon_db"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.cache_dir)"
                    },
                    "id": "#prime_cache.cwl/asn_cache"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.seq_ids_name)"
                    },
                    "id": "#prime_cache.cwl/oseq_ids"
                }
            ],
            "id": "#prime_cache.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "screen_evaluate",
            "label": "screen_evaluate",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-asn"
                    },
                    "id": "#screen_evaluate.cwl/asn"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "-ifmt"
                    },
                    "id": "#screen_evaluate.cwl/ifmt"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "prefix": "-ignore-all-errors"
                    },
                    "id": "#screen_evaluate.cwl/ignore_all_errors"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "prefix": "-it"
                    },
                    "id": "#screen_evaluate.cwl/it"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-tab"
                    },
                    "id": "#screen_evaluate.cwl/tab"
                }
            ],
            "outputs": [
                {
                    "type": "boolean",
                    "outputBinding": {
                        "outputEval": "$(true)"
                    },
                    "id": "#screen_evaluate.cwl/success"
                }
            ],
            "id": "#screen_evaluate.cwl"
        },
        {
            "class": "CommandLineTool",
            "id": "#univec_wnode.cwl",
            "baseCommand": "univec_wnode",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.blastdb_dir)",
                            "writable": false
                        },
                        {
                            "entry": "$(inputs.asn_cache)",
                            "writable": false
                        }
                    ]
                }
            ],
            "arguments": [
                "-nogenbank"
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "output",
                    "doc": "Base path to files of output generated from processes",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-O"
                    },
                    "id": "#univec_wnode.cwl/univec_wnode/O"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-asn-cache"
                    },
                    "id": "#univec_wnode.cwl/univec_wnode/asn_cache"
                },
                {
                    "type": "Directory",
                    "doc": "Hidden parameter, hidden within input_jobs:",
                    "id": "#univec_wnode.cwl/univec_wnode/blastdb_dir"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-input-jobs"
                    },
                    "label": "input_jobs",
                    "doc": "XML file with input univec jobs, this parameter is _referential_ which CWL does not like.\n",
                    "id": "#univec_wnode.cwl/univec_wnode/input_jobs"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.O)"
                    },
                    "id": "#univec_wnode.cwl/univec_wnode/outdir"
                }
            ],
            "label": "univec_wnode"
        },
        {
            "label": "tt_blastn_wnode",
            "class": "Workflow",
            "requirements": [
                {
                    "class": "MultipleInputFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#tt_blastn_wnode.cwl/affinity"
                },
                {
                    "type": "Directory",
                    "id": "#tt_blastn_wnode.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "id": "#tt_blastn_wnode.cwl/best_hit_overhang"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "id": "#tt_blastn_wnode.cwl/best_hit_score_edge"
                },
                {
                    "type": "string",
                    "id": "#tt_blastn_wnode.cwl/blastdb"
                },
                {
                    "type": "Directory",
                    "id": "#tt_blastn_wnode.cwl/blastdb_dir"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#tt_blastn_wnode.cwl/dust"
                },
                {
                    "type": "float",
                    "id": "#tt_blastn_wnode.cwl/evalue"
                },
                {
                    "type": "File",
                    "id": "#tt_blastn_wnode.cwl/ids_out"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#tt_blastn_wnode.cwl/max_batch_length"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#tt_blastn_wnode.cwl/max_target_seqs"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "id": "#tt_blastn_wnode.cwl/perc_identity"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#tt_blastn_wnode.cwl/soft_masking"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#tt_blastn_wnode.cwl/task"
                },
                {
                    "type": "int",
                    "id": "#tt_blastn_wnode.cwl/word_size"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#tt_blastn_wnode.cwl/gpx_make_outputs/output_file",
                    "id": "#tt_blastn_wnode.cwl/blast_align"
                }
            ],
            "steps": [
                {
                    "run": "#blastn_wnode.cwl",
                    "in": [
                        {
                            "source": "#tt_blastn_wnode.cwl/asn_cache",
                            "id": "#tt_blastn_wnode.cwl/blastn_wnode/asn_cache"
                        },
                        {
                            "source": "#tt_blastn_wnode.cwl/best_hit_overhang",
                            "id": "#tt_blastn_wnode.cwl/blastn_wnode/best_hit_overhang"
                        },
                        {
                            "source": "#tt_blastn_wnode.cwl/best_hit_score_edge",
                            "id": "#tt_blastn_wnode.cwl/blastn_wnode/best_hit_score_edge"
                        },
                        {
                            "source": "#tt_blastn_wnode.cwl/blastdb",
                            "id": "#tt_blastn_wnode.cwl/blastn_wnode/blastdb"
                        },
                        {
                            "source": "#tt_blastn_wnode.cwl/blastdb_dir",
                            "id": "#tt_blastn_wnode.cwl/blastn_wnode/blastdb_dir"
                        },
                        {
                            "source": "#tt_blastn_wnode.cwl/dust",
                            "id": "#tt_blastn_wnode.cwl/blastn_wnode/dust"
                        },
                        {
                            "source": "#tt_blastn_wnode.cwl/evalue",
                            "id": "#tt_blastn_wnode.cwl/blastn_wnode/evalue"
                        },
                        {
                            "source": "#tt_blastn_wnode.cwl/gpx_qsubmit/jobs",
                            "id": "#tt_blastn_wnode.cwl/blastn_wnode/input_jobs"
                        },
                        {
                            "source": "#tt_blastn_wnode.cwl/max_target_seqs",
                            "id": "#tt_blastn_wnode.cwl/blastn_wnode/max_target_seqs"
                        },
                        {
                            "source": "#tt_blastn_wnode.cwl/perc_identity",
                            "id": "#tt_blastn_wnode.cwl/blastn_wnode/perc_identity"
                        },
                        {
                            "default": "true",
                            "id": "#tt_blastn_wnode.cwl/blastn_wnode/soft_masking"
                        },
                        {
                            "default": false,
                            "id": "#tt_blastn_wnode.cwl/blastn_wnode/swap_rows"
                        },
                        {
                            "default": "blastn",
                            "id": "#tt_blastn_wnode.cwl/blastn_wnode/task"
                        },
                        {
                            "source": "#tt_blastn_wnode.cwl/word_size",
                            "id": "#tt_blastn_wnode.cwl/blastn_wnode/word_size"
                        }
                    ],
                    "out": [
                        "#tt_blastn_wnode.cwl/blastn_wnode/outdir"
                    ],
                    "id": "#tt_blastn_wnode.cwl/blastn_wnode"
                },
                {
                    "run": "#gpx_make_outputs.cwl",
                    "in": [
                        {
                            "source": "#tt_blastn_wnode.cwl/blastn_wnode/outdir",
                            "id": "#tt_blastn_wnode.cwl/gpx_make_outputs/input_path"
                        },
                        {
                            "default": 1,
                            "id": "#tt_blastn_wnode.cwl/gpx_make_outputs/num_partitions"
                        },
                        {
                            "default": "blast.#.asn",
                            "id": "#tt_blastn_wnode.cwl/gpx_make_outputs/output"
                        },
                        {
                            "default": "blast.*.asn",
                            "id": "#tt_blastn_wnode.cwl/gpx_make_outputs/output_glob"
                        }
                    ],
                    "out": [
                        "#tt_blastn_wnode.cwl/gpx_make_outputs/output_file"
                    ],
                    "id": "#tt_blastn_wnode.cwl/gpx_make_outputs"
                },
                {
                    "run": "#gpx_qsubmit.cwl",
                    "in": [
                        {
                            "source": "#tt_blastn_wnode.cwl/affinity",
                            "id": "#tt_blastn_wnode.cwl/gpx_qsubmit/affinity"
                        },
                        {
                            "source": [
                                "#tt_blastn_wnode.cwl/asn_cache"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#tt_blastn_wnode.cwl/gpx_qsubmit/asn_cache"
                        },
                        {
                            "source": [
                                "#tt_blastn_wnode.cwl/blastdb"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#tt_blastn_wnode.cwl/gpx_qsubmit/blastdb"
                        },
                        {
                            "source": "#tt_blastn_wnode.cwl/blastdb_dir",
                            "id": "#tt_blastn_wnode.cwl/gpx_qsubmit/blastdb_dir"
                        },
                        {
                            "source": [
                                "#tt_blastn_wnode.cwl/ids_out"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#tt_blastn_wnode.cwl/gpx_qsubmit/ids"
                        },
                        {
                            "source": "#tt_blastn_wnode.cwl/max_batch_length",
                            "id": "#tt_blastn_wnode.cwl/gpx_qsubmit/max_batch_length"
                        },
                        {
                            "default": true,
                            "id": "#tt_blastn_wnode.cwl/gpx_qsubmit/nogenbank"
                        },
                        {
                            "default": {
                                "class": "File",
                                "path": "https://raw.githubusercontent.com/dev/null",
                                "basename": "null",
                                "contents": ""
                            },
                            "id": "#tt_blastn_wnode.cwl/gpx_qsubmit/proteins"
                        }
                    ],
                    "out": [
                        "#tt_blastn_wnode.cwl/gpx_qsubmit/jobs"
                    ],
                    "id": "#tt_blastn_wnode.cwl/gpx_qsubmit"
                }
            ],
            "id": "#tt_blastn_wnode.cwl"
        },
        {
            "label": "tt_fscr_calls_pass1",
            "class": "Workflow",
            "inputs": [
                {
                    "type": "Directory",
                    "id": "#tt_fscr_calls_pass1.cwl/asn_cache"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#tt_fscr_calls_pass1.cwl/input"
                }
            ],
            "steps": [
                {
                    "run": "#fscr_calls_pass1.cwl",
                    "label": "fscr_calls_pass1",
                    "in": [
                        {
                            "source": "#tt_fscr_calls_pass1.cwl/asn_cache",
                            "id": "#tt_fscr_calls_pass1.cwl/fscr_calls_pass1/asn_cache"
                        },
                        {
                            "source": "#tt_fscr_calls_pass1.cwl/input",
                            "id": "#tt_fscr_calls_pass1.cwl/fscr_calls_pass1/input"
                        },
                        {
                            "default": 50000,
                            "id": "#tt_fscr_calls_pass1.cwl/fscr_calls_pass1/max_reblast_spans"
                        },
                        {
                            "default": 300,
                            "id": "#tt_fscr_calls_pass1.cwl/fscr_calls_pass1/repeat_threshold"
                        }
                    ],
                    "out": [
                        "#tt_fscr_calls_pass1.cwl/fscr_calls_pass1/calls",
                        "#tt_fscr_calls_pass1.cwl/fscr_calls_pass1/reblast_locs",
                        "#tt_fscr_calls_pass1.cwl/fscr_calls_pass1/masked_locs"
                    ],
                    "id": "#tt_fscr_calls_pass1.cwl/fscr_calls_pass1"
                },
                {
                    "run": "#fscr_format_calls.cwl",
                    "in": [
                        {
                            "source": "#tt_fscr_calls_pass1.cwl/fscr_calls_pass1/calls",
                            "id": "#tt_fscr_calls_pass1.cwl/fscr_format_calls/calls"
                        }
                    ],
                    "out": [
                        "#tt_fscr_calls_pass1.cwl/fscr_format_calls/o"
                    ],
                    "id": "#tt_fscr_calls_pass1.cwl/fscr_format_calls"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#tt_fscr_calls_pass1.cwl/fscr_format_calls/o",
                    "id": "#tt_fscr_calls_pass1.cwl/calls"
                }
            ],
            "id": "#tt_fscr_calls_pass1.cwl"
        },
        {
            "class": "Workflow",
            "id": "#tt_univec_wnode.cwl",
            "doc": "univ_wnode",
            "label": "univec_wnode",
            "requirements": [
                {
                    "class": "MultipleInputFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "id": "#tt_univec_wnode.cwl/tt_univec_wnode/asn_cache"
                },
                {
                    "type": "string",
                    "id": "#tt_univec_wnode.cwl/tt_univec_wnode/blastdb"
                },
                {
                    "type": "Directory",
                    "id": "#tt_univec_wnode.cwl/tt_univec_wnode/blastdb_dir"
                },
                {
                    "type": "File",
                    "id": "#tt_univec_wnode.cwl/tt_univec_wnode/gilist"
                }
            ],
            "steps": [
                {
                    "run": "#generate_fscr_feats.cwl",
                    "label": "generate_fscr_feats",
                    "in": [
                        {
                            "source": "#tt_univec_wnode.cwl/tt_univec_wnode/gpx_qdump/output",
                            "id": "#tt_univec_wnode.cwl/tt_univec_wnode/generate_fscr_feats/input"
                        },
                        {
                            "default": "Adaptor",
                            "id": "#tt_univec_wnode.cwl/tt_univec_wnode/generate_fscr_feats/label_suffix"
                        },
                        {
                            "default": "fscr_feats.asn",
                            "id": "#tt_univec_wnode.cwl/tt_univec_wnode/generate_fscr_feats/o"
                        },
                        {
                            "default": "vector",
                            "id": "#tt_univec_wnode.cwl/tt_univec_wnode/generate_fscr_feats/source"
                        }
                    ],
                    "out": [
                        "#tt_univec_wnode.cwl/tt_univec_wnode/generate_fscr_feats/feats"
                    ],
                    "id": "#tt_univec_wnode.cwl/tt_univec_wnode/generate_fscr_feats"
                },
                {
                    "run": "#gpx_qdump.cwl",
                    "label": "gpx_qdump",
                    "in": [
                        {
                            "source": "#tt_univec_wnode.cwl/tt_univec_wnode/univec_wnode/outdir",
                            "id": "#tt_univec_wnode.cwl/tt_univec_wnode/gpx_qdump/input_path"
                        },
                        {
                            "default": "*",
                            "id": "#tt_univec_wnode.cwl/tt_univec_wnode/gpx_qdump/unzip"
                        }
                    ],
                    "out": [
                        "#tt_univec_wnode.cwl/tt_univec_wnode/gpx_qdump/output"
                    ],
                    "id": "#tt_univec_wnode.cwl/tt_univec_wnode/gpx_qdump"
                },
                {
                    "run": "#gpx_qsubmit.cwl",
                    "label": "gpx_qsubmit",
                    "in": [
                        {
                            "source": [
                                "#tt_univec_wnode.cwl/tt_univec_wnode/asn_cache"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#tt_univec_wnode.cwl/tt_univec_wnode/gpx_qsubmit/asn_cache"
                        },
                        {
                            "source": [
                                "#tt_univec_wnode.cwl/tt_univec_wnode/blastdb"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#tt_univec_wnode.cwl/tt_univec_wnode/gpx_qsubmit/blastdb"
                        },
                        {
                            "source": "#tt_univec_wnode.cwl/tt_univec_wnode/blastdb_dir",
                            "id": "#tt_univec_wnode.cwl/tt_univec_wnode/gpx_qsubmit/blastdb_dir"
                        },
                        {
                            "source": [
                                "#tt_univec_wnode.cwl/tt_univec_wnode/gilist"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#tt_univec_wnode.cwl/tt_univec_wnode/gpx_qsubmit/ids"
                        },
                        {
                            "default": {
                                "class": "File",
                                "path": "https://raw.githubusercontent.com/dev/null",
                                "basename": "null",
                                "contents": ""
                            },
                            "id": "#tt_univec_wnode.cwl/tt_univec_wnode/gpx_qsubmit/proteins"
                        }
                    ],
                    "out": [
                        "#tt_univec_wnode.cwl/tt_univec_wnode/gpx_qsubmit/jobs"
                    ],
                    "id": "#tt_univec_wnode.cwl/tt_univec_wnode/gpx_qsubmit"
                },
                {
                    "run": "#univec_wnode.cwl",
                    "label": "univec_wnode",
                    "in": [
                        {
                            "source": "#tt_univec_wnode.cwl/tt_univec_wnode/asn_cache",
                            "id": "#tt_univec_wnode.cwl/tt_univec_wnode/univec_wnode/asn_cache"
                        },
                        {
                            "source": "#tt_univec_wnode.cwl/tt_univec_wnode/blastdb_dir",
                            "id": "#tt_univec_wnode.cwl/tt_univec_wnode/univec_wnode/blastdb_dir"
                        },
                        {
                            "source": "#tt_univec_wnode.cwl/tt_univec_wnode/gpx_qsubmit/jobs",
                            "id": "#tt_univec_wnode.cwl/tt_univec_wnode/univec_wnode/input_jobs"
                        }
                    ],
                    "out": [
                        "#tt_univec_wnode.cwl/tt_univec_wnode/univec_wnode/outdir"
                    ],
                    "id": "#tt_univec_wnode.cwl/tt_univec_wnode/univec_wnode"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#tt_univec_wnode.cwl/tt_univec_wnode/generate_fscr_feats/feats",
                    "id": "#tt_univec_wnode.cwl/tt_univec_wnode/feats"
                },
                {
                    "type": "File",
                    "outputSource": "#tt_univec_wnode.cwl/tt_univec_wnode/gpx_qdump/output",
                    "id": "#tt_univec_wnode.cwl/tt_univec_wnode/hits"
                }
            ]
        },
        {
            "class": "Workflow",
            "id": "#bacterial_screening.cwl",
            "label": "bacterial_screening",
            "requirements": [
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "id": "#bacterial_screening.cwl/bacterial_screening/asn_cache"
                },
                {
                    "type": "Directory",
                    "id": "#bacterial_screening.cwl/bacterial_screening/contam_in_prok_blastdb_dir"
                },
                {
                    "type": "File",
                    "id": "#bacterial_screening.cwl/bacterial_screening/contig_gilist"
                }
            ],
            "steps": [
                {
                    "run": "#tt_blastn_wnode.cwl",
                    "in": [
                        {
                            "source": "#bacterial_screening.cwl/bacterial_screening/asn_cache",
                            "id": "#bacterial_screening.cwl/bacterial_screening/BLAST_Against_contam_in_prok/asn_cache"
                        },
                        {
                            "default": 0.1,
                            "id": "#bacterial_screening.cwl/bacterial_screening/BLAST_Against_contam_in_prok/best_hit_overhang"
                        },
                        {
                            "default": 0.1,
                            "id": "#bacterial_screening.cwl/bacterial_screening/BLAST_Against_contam_in_prok/best_hit_score_edge"
                        },
                        {
                            "default": "contam_in_prok",
                            "id": "#bacterial_screening.cwl/bacterial_screening/BLAST_Against_contam_in_prok/blastdb"
                        },
                        {
                            "source": "#bacterial_screening.cwl/bacterial_screening/contam_in_prok_blastdb_dir",
                            "id": "#bacterial_screening.cwl/bacterial_screening/BLAST_Against_contam_in_prok/blastdb_dir"
                        },
                        {
                            "default": "yes",
                            "id": "#bacterial_screening.cwl/bacterial_screening/BLAST_Against_contam_in_prok/dust"
                        },
                        {
                            "default": 0.0001,
                            "id": "#bacterial_screening.cwl/bacterial_screening/BLAST_Against_contam_in_prok/evalue"
                        },
                        {
                            "source": "#bacterial_screening.cwl/bacterial_screening/contig_gilist",
                            "id": "#bacterial_screening.cwl/bacterial_screening/BLAST_Against_contam_in_prok/ids_out"
                        },
                        {
                            "default": 90,
                            "id": "#bacterial_screening.cwl/bacterial_screening/BLAST_Against_contam_in_prok/perc_identity"
                        },
                        {
                            "default": "megablast",
                            "id": "#bacterial_screening.cwl/bacterial_screening/BLAST_Against_contam_in_prok/task"
                        },
                        {
                            "default": 28,
                            "id": "#bacterial_screening.cwl/bacterial_screening/BLAST_Against_contam_in_prok/word_size"
                        }
                    ],
                    "out": [
                        "#bacterial_screening.cwl/bacterial_screening/BLAST_Against_contam_in_prok/blast_align"
                    ],
                    "id": "#bacterial_screening.cwl/bacterial_screening/BLAST_Against_contam_in_prok"
                },
                {
                    "run": "#align_filter.cwl",
                    "label": "align_filter",
                    "in": [
                        {
                            "source": [
                                "#bacterial_screening.cwl/bacterial_screening/asn_cache"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#bacterial_screening.cwl/bacterial_screening/Filter_contam_in_prok_BLAST_Results/asn_cache"
                        },
                        {
                            "default": " (align_length >= 50 && pct_identity_gap >= 98) || (align_length >= 100 && pct_identity_gap >= 94) || (align_length >= 200 && pct_identity_gap >= 90)",
                            "id": "#bacterial_screening.cwl/bacterial_screening/Filter_contam_in_prok_BLAST_Results/filter"
                        },
                        {
                            "default": "seq-align-set",
                            "id": "#bacterial_screening.cwl/bacterial_screening/Filter_contam_in_prok_BLAST_Results/ifmt"
                        },
                        {
                            "source": [
                                "#bacterial_screening.cwl/bacterial_screening/BLAST_Against_contam_in_prok/blast_align"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#bacterial_screening.cwl/bacterial_screening/Filter_contam_in_prok_BLAST_Results/input"
                        },
                        {
                            "source": "#bacterial_screening.cwl/bacterial_screening/Find_Frequent_contam_in_prok_Hits/frequent",
                            "id": "#bacterial_screening.cwl/bacterial_screening/Filter_contam_in_prok_BLAST_Results/subject_allowlist"
                        }
                    ],
                    "out": [
                        "#bacterial_screening.cwl/bacterial_screening/Filter_contam_in_prok_BLAST_Results/o",
                        "#bacterial_screening.cwl/bacterial_screening/Filter_contam_in_prok_BLAST_Results/onon_match"
                    ],
                    "id": "#bacterial_screening.cwl/bacterial_screening/Filter_contam_in_prok_BLAST_Results"
                },
                {
                    "in": [
                        {
                            "source": "#bacterial_screening.cwl/bacterial_screening/BLAST_Against_contam_in_prok/blast_align",
                            "id": "#bacterial_screening.cwl/bacterial_screening/Find_Frequent_contam_in_prok_Hits/align"
                        }
                    ],
                    "out": [
                        "#bacterial_screening.cwl/bacterial_screening/Find_Frequent_contam_in_prok_Hits/frequent"
                    ],
                    "run": "#align_find_frequent_sas.cwl",
                    "label": "align_find_frequent_sas",
                    "id": "#bacterial_screening.cwl/bacterial_screening/Find_Frequent_contam_in_prok_Hits"
                },
                {
                    "in": [
                        {
                            "source": "#bacterial_screening.cwl/bacterial_screening/Filter_contam_in_prok_BLAST_Results/o",
                            "id": "#bacterial_screening.cwl/bacterial_screening/Generate_contam_in_prok_hit_features/input"
                        },
                        {
                            "default": "contam_in_prok",
                            "id": "#bacterial_screening.cwl/bacterial_screening/Generate_contam_in_prok_hit_features/label_suffix"
                        },
                        {
                            "default": "feats.asn",
                            "id": "#bacterial_screening.cwl/bacterial_screening/Generate_contam_in_prok_hit_features/o"
                        },
                        {
                            "default": "vector",
                            "id": "#bacterial_screening.cwl/bacterial_screening/Generate_contam_in_prok_hit_features/source"
                        }
                    ],
                    "out": [
                        "#bacterial_screening.cwl/bacterial_screening/Generate_contam_in_prok_hit_features/feats"
                    ],
                    "run": "#generate_fscr_feats.cwl",
                    "label": "generate_fscr_feats",
                    "id": "#bacterial_screening.cwl/bacterial_screening/Generate_contam_in_prok_hit_features"
                }
            ],
            "outputs": [
                {
                    "outputSource": "#bacterial_screening.cwl/bacterial_screening/BLAST_Against_contam_in_prok/blast_align",
                    "type": "File",
                    "id": "#bacterial_screening.cwl/bacterial_screening/blast_align"
                },
                {
                    "outputSource": "#bacterial_screening.cwl/bacterial_screening/Generate_contam_in_prok_hit_features/feats",
                    "type": "File",
                    "id": "#bacterial_screening.cwl/bacterial_screening/feats"
                },
                {
                    "outputSource": "#bacterial_screening.cwl/bacterial_screening/Filter_contam_in_prok_BLAST_Results/o",
                    "type": "File",
                    "id": "#bacterial_screening.cwl/bacterial_screening/filtered_align"
                }
            ]
        },
        {
            "class": "Workflow",
            "id": "#foreign_screening.cwl",
            "label": "foreign_screening",
            "requirements": [
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#foreign_screening.cwl/foreign_screening/adaptor_fasta"
                },
                {
                    "type": "File",
                    "id": "#foreign_screening.cwl/foreign_screening/contig_fasta"
                }
            ],
            "steps": [
                {
                    "run": "#tt_univec_wnode.cwl",
                    "label": "univec_wnode",
                    "in": [
                        {
                            "source": "#foreign_screening.cwl/foreign_screening/Cache_WGS_contig_FASTA/asn_cache",
                            "id": "#foreign_screening.cwl/foreign_screening/Align_To_Adaptor/asn_cache"
                        },
                        {
                            "default": "blastdb",
                            "id": "#foreign_screening.cwl/foreign_screening/Align_To_Adaptor/blastdb"
                        },
                        {
                            "source": "#foreign_screening.cwl/foreign_screening/Create_Adaptor_BLASTdb/blastdb",
                            "id": "#foreign_screening.cwl/foreign_screening/Align_To_Adaptor/blastdb_dir"
                        },
                        {
                            "source": "#foreign_screening.cwl/foreign_screening/Cache_WGS_contig_FASTA/oseq_ids",
                            "id": "#foreign_screening.cwl/foreign_screening/Align_To_Adaptor/gilist"
                        }
                    ],
                    "out": [
                        "#foreign_screening.cwl/foreign_screening/Align_To_Adaptor/feats",
                        "#foreign_screening.cwl/foreign_screening/Align_To_Adaptor/hits"
                    ],
                    "id": "#foreign_screening.cwl/foreign_screening/Align_To_Adaptor"
                },
                {
                    "run": "#prime_cache.cwl",
                    "label": "prime_cache",
                    "in": [
                        {
                            "source": "#foreign_screening.cwl/foreign_screening/contig_fasta",
                            "id": "#foreign_screening.cwl/foreign_screening/Cache_WGS_contig_FASTA/input"
                        }
                    ],
                    "out": [
                        "#foreign_screening.cwl/foreign_screening/Cache_WGS_contig_FASTA/asn_cache",
                        "#foreign_screening.cwl/foreign_screening/Cache_WGS_contig_FASTA/oseq_ids"
                    ],
                    "id": "#foreign_screening.cwl/foreign_screening/Cache_WGS_contig_FASTA"
                },
                {
                    "run": "#gp_makeblastdb.cwl",
                    "label": "gp_makeblastdb",
                    "in": [
                        {
                            "source": [
                                "#foreign_screening.cwl/foreign_screening/Cache_WGS_contig_FASTA/asn_cache"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#foreign_screening.cwl/foreign_screening/Create_Adaptor_BLASTdb/asn_cache"
                        },
                        {
                            "default": "nucl",
                            "id": "#foreign_screening.cwl/foreign_screening/Create_Adaptor_BLASTdb/dbtype"
                        },
                        {
                            "source": "#foreign_screening.cwl/foreign_screening/adaptor_fasta",
                            "id": "#foreign_screening.cwl/foreign_screening/Create_Adaptor_BLASTdb/fasta"
                        },
                        {
                            "default": "BLASTdb created by GPipe",
                            "id": "#foreign_screening.cwl/foreign_screening/Create_Adaptor_BLASTdb/title"
                        }
                    ],
                    "out": [
                        "#foreign_screening.cwl/foreign_screening/Create_Adaptor_BLASTdb/blastdb"
                    ],
                    "id": "#foreign_screening.cwl/foreign_screening/Create_Adaptor_BLASTdb"
                }
            ],
            "outputs": [
                {
                    "outputSource": "#foreign_screening.cwl/foreign_screening/Create_Adaptor_BLASTdb/blastdb",
                    "type": "Directory",
                    "id": "#foreign_screening.cwl/foreign_screening/adaptor_blastdb_dir"
                },
                {
                    "outputSource": "#foreign_screening.cwl/foreign_screening/Cache_WGS_contig_FASTA/oseq_ids",
                    "type": "File",
                    "id": "#foreign_screening.cwl/foreign_screening/contig_ids_out"
                },
                {
                    "outputSource": "#foreign_screening.cwl/foreign_screening/Align_To_Adaptor/feats",
                    "type": "File",
                    "id": "#foreign_screening.cwl/foreign_screening/feats"
                },
                {
                    "outputSource": "#foreign_screening.cwl/foreign_screening/Align_To_Adaptor/hits",
                    "type": "File",
                    "id": "#foreign_screening.cwl/foreign_screening/hits"
                },
                {
                    "outputSource": "#foreign_screening.cwl/foreign_screening/Cache_WGS_contig_FASTA/asn_cache",
                    "type": "Directory",
                    "id": "#foreign_screening.cwl/foreign_screening/out_cache_dir"
                }
            ]
        },
        {
            "class": "Workflow",
            "id": "#main",
            "label": "vecscreen",
            "requirements": [
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#main/adaptor_fasta",
                    "type": "File"
                },
                {
                    "id": "#main/contam_in_prok_blastdb_dir",
                    "type": "Directory"
                },
                {
                    "id": "#main/contig_fasta",
                    "type": "File"
                },
                {
                    "id": "#main/ignore_all_errors",
                    "type": [
                        "null",
                        "boolean"
                    ]
                }
            ],
            "steps": [
                {
                    "run": "#tt_fscr_calls_pass1.cwl",
                    "in": [
                        {
                            "source": "#main/default_plane/out_cache_dir",
                            "id": "#main/FSCR_Calls_first_pass/asn_cache"
                        },
                        {
                            "source": [
                                "#main/bacterial_screening/feats",
                                "#main/default_plane/feats"
                            ],
                            "id": "#main/FSCR_Calls_first_pass/input"
                        }
                    ],
                    "out": [
                        "#main/FSCR_Calls_first_pass/calls"
                    ],
                    "doc": "corresponds to part of default plane in foreign contamination screening graph of classic Gpipe it should go _after_ all screenings, so it goes to a separate degenerate \"plane\" = \"task\" here",
                    "id": "#main/FSCR_Calls_first_pass"
                },
                {
                    "run": "#bacterial_screening.cwl",
                    "label": "bacterial_screening",
                    "doc": "corresponds to bacterial_screening plane in in foreign contamination screening graph of classic Gpipe",
                    "in": [
                        {
                            "source": "#main/default_plane/out_cache_dir",
                            "id": "#main/bacterial_screening/asn_cache"
                        },
                        {
                            "source": "#main/contam_in_prok_blastdb_dir",
                            "id": "#main/bacterial_screening/contam_in_prok_blastdb_dir"
                        },
                        {
                            "source": "#main/default_plane/contig_ids_out",
                            "id": "#main/bacterial_screening/contig_gilist"
                        }
                    ],
                    "out": [
                        "#main/bacterial_screening/blast_align",
                        "#main/bacterial_screening/feats",
                        "#main/bacterial_screening/filtered_align"
                    ],
                    "id": "#main/bacterial_screening"
                },
                {
                    "run": "#foreign_screening.cwl",
                    "label": "foreign_screening",
                    "doc": "corresponds to part of default plane in foreign contamination screening graph of classic Gpipe it does bunch of generic things so it has to be first",
                    "in": [
                        {
                            "source": "#main/adaptor_fasta",
                            "id": "#main/default_plane/adaptor_fasta"
                        },
                        {
                            "source": "#main/contig_fasta",
                            "id": "#main/default_plane/contig_fasta"
                        }
                    ],
                    "out": [
                        "#main/default_plane/adaptor_blastdb_dir",
                        "#main/default_plane/contig_ids_out",
                        "#main/default_plane/feats",
                        "#main/default_plane/hits",
                        "#main/default_plane/out_cache_dir"
                    ],
                    "id": "#main/default_plane"
                },
                {
                    "run": "#screen_evaluate.cwl",
                    "in": [
                        {
                            "default": "seq-annot",
                            "id": "#main/screen_evaluate/ifmt"
                        },
                        {
                            "source": "#main/ignore_all_errors",
                            "id": "#main/screen_evaluate/ignore_all_errors"
                        },
                        {
                            "source": "#main/FSCR_Calls_first_pass/calls",
                            "id": "#main/screen_evaluate/tab"
                        }
                    ],
                    "out": [
                        "#main/screen_evaluate/success"
                    ],
                    "id": "#main/screen_evaluate"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputSource": "#main/default_plane/adaptor_blastdb_dir",
                    "id": "#main/adaptor_blastdb_dir"
                },
                {
                    "type": "File",
                    "outputSource": "#main/bacterial_screening/blast_align",
                    "id": "#main/blast_align"
                },
                {
                    "type": "File",
                    "outputSource": "#main/FSCR_Calls_first_pass/calls",
                    "id": "#main/calls"
                },
                {
                    "type": "File",
                    "outputSource": "#main/bacterial_screening/feats",
                    "id": "#main/contamination_feats"
                },
                {
                    "type": "File",
                    "outputSource": "#main/bacterial_screening/filtered_align",
                    "id": "#main/filtered_align"
                },
                {
                    "type": "File",
                    "outputSource": "#main/default_plane/feats",
                    "id": "#main/foreign_feats"
                },
                {
                    "type": "File",
                    "outputSource": "#main/default_plane/hits",
                    "id": "#main/hits"
                },
                {
                    "type": "Directory",
                    "outputSource": "#main/default_plane/out_cache_dir",
                    "id": "#main/out_cache_dir"
                },
                {
                    "type": "boolean",
                    "outputSource": "#main/screen_evaluate/success",
                    "id": "#main/success"
                }
            ]
        }
    ],
    "cwlVersion": "v1.2"
}
